#include "fwl5.h"
#pragma hdrstop
#include <commctrl.h>
#include <stdexcpt.h>
#include <crtdbg.h>
#include "exnames.h"
Application* Application::it=0;

//----------------------------------------------------------------------------
void Application::PostWindowCreate(BaseWin*)
{
}
#include "extrans.h"
unsigned SE_Exception::se=0;
void trans_func( unsigned, _EXCEPTION_POINTERS*);

//----------------------------------------------------------------------------
int Application::Run()
{
  static char buf[80];
  static DWORD excode;

  WNDCLASSEX wc;
  wc.cbSize = sizeof(wc);
  wc.lpfnWndProc = Window::handler;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 4;
  wc.hInstance = thisInstance;
  wc.hIcon = LoadIcon(thisInstance, MAKEINTRESOURCE(32000));
  wc.hIconSm = (HICON)LoadImage(thisInstance, MAKEINTRESOURCE(32000), IMAGE_ICON, 16, 16, 0);
  wc.hCursor = LoadCursor(0, IDC_ARROW);
  wc.hbrBackground = GetMainBrush();
  wc.style = CS_BYTEALIGNCLIENT;
  wc.lpszMenuName = 0;
  wc.lpszClassName = "L5";
  RegisterClassEx(&wc);

  _CrtSetReportMode(_CRT_WARN,_CRTDBG_MODE_DEBUG	/*|_CRTDBG_MODE_WNDW*/);
  _CrtSetReportMode(_CRT_ERROR,_CRTDBG_MODE_DEBUG/*	|_CRTDBG_MODE_WNDW*/);
  _CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_DEBUG	|_CRTDBG_MODE_WNDW);
  int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );

  tmpFlag |= _CRTDBG_LEAK_CHECK_DF;

  // Turn Off (AND) - prevent _CrtCheckMemory from
  // being called at every allocation request
  tmpFlag &= ~_CRTDBG_CHECK_ALWAYS_DF;

  // Set the new state for the flag
  _CrtSetDbgFlag( tmpFlag );
  
  InitCommonControls();
  _set_se_translator( trans_func );

  try
  {
    mainWindow = CreateMainWindow();
    int rv = 1;
    if (mainWindow->Create())
    {
      PostWindowCreate(mainWindow);
      rv = MessageLoop();
      //_CrtDumpMemoryLeaks();
    }
    return rv;
  }
  catch (exception x)
  {
    ::MessageBox(0, x.what(),"Exception!", MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
    OutputDebugString("Exception ");
    OutputDebugString(x.what());
    OutputDebugString("\n");
    mainWindow->Destroy();
  }
  catch( SE_Exception e )
  {
    strcpy(buf, "SE code               ");
    excode = e.getSeNumber();
    const char* np = Exname(SE_Exception::se);
    if (np)
    {
      strcpy(buf+8, np);
    }
    else
    {
      _itoa(SE_Exception::se, buf+8, 16);
    }
    ::MessageBox(0, buf, "C exception!", MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
    OutputDebugString("Exception ");
    OutputDebugString(buf);
    OutputDebugString("\n");
    mainWindow->Destroy();
  }
  catch (int y)
  {
    _itoa(y, buf, 10);
    ::MessageBox(0, buf, "Int exception!", MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
    OutputDebugString("Int Exception ");
    OutputDebugString(buf);
    OutputDebugString("\n");
  }
  catch (...)
  {
    ::MessageBox(0, "Something wonderful is happening!","Exception!", MB_OK|MB_ICONHAND|MB_SYSTEMMODAL);
  }
  return 3;
}
void trans_func( unsigned int u, _EXCEPTION_POINTERS* pExp )
{  
  SE_Exception::se = u;
  throw SE_Exception( u );
}
//----------------------------------------------------------------------------
BaseWin* Application::CreateMainWindow()
{
  Window* w = new Window();
  int swidth = GetSystemMetrics(SM_CXSCREEN);
  int sheight = GetSystemMetrics(SM_CYSCREEN);
  CRect winRect;
  winRect.left = (swidth-640)/2;
  winRect.top = (sheight-480)/2;
  winRect.SetSize(CSize(640,480));
  w->Move(winRect);
  w->SetStyle(WS_POPUP | WS_BORDER | WS_CAPTION);
  w->SetTitle("Ready!");
  return w;
}
//----------------------------------------------------------------------------
HBRUSH Application::GetMainBrush()
{
  return (HBRUSH)(COLOR_WINDOW+1);
}

//----------------------------------------------------------------------------
Application::~Application()
{
}

//----------------------------------------------------------------------------
int Application::MessageLoop()
{
  BaseWin *w = mainWindow;
  activeWin = w;
  w->Show();
  w->UpdateAll();

  MSG m;
  while (1)
  {
    if (PeekMessage(&m, 0, 0, 0, PM_REMOVE))
    {
      if (m.message == WM_QUIT)
      {
        break;
      }
      // If the client window wishes to be afforded tabbing between buttons
      // like when a producer says "Isn't the tab key supposed to work?"
      // the window should return TRUE from WantsDialogKeys.
      // This interferes with some ways of using WM_KEYDOWN, a lot, so
      // sometimes return FALSE from WantsDialogKeys.
      // When modeless property sheets are permitted,
      // PropSheet_IsDialogMessage and a CHECKED dynamic_cast will be required
      // to deal with dialog messages of the property sheet.
      if (!w->WantsDialogKeys() || !IsDialogMessage(activeWin->GetHWND(), &m))
      {
        TranslateMessage(&m);
        DispatchMessage(&m);
      }
    }
    else
    {
      if (w->Idle())
      {
        WaitMessage();
      }
    }
  }
  delete w;
  return 0;
}

