; =========================================================               
; CSX.INC: This file contains the includes needed for the
; Atari DSP implementation of CSX Synthesis. It should be
; included in each DAS file needed.
; =========================================================
; Copyright, 1995 Atari Corporation.
; Written for Atari by Highlight Software Solutions.
; =========================================================
; =========================================================

; AUDIO OUT ISR REGISTERS
; -----------------------
; Registers that should be left for single use of the audio
; out functions in the ISR. They should be initialized, and
; left alone by all main thread software.
	AOUT_LEFT       .EQUR           r11     ; Audio Left DAC Address
	AOUT_RIGHT      .EQUR           r10     ; Audio Right DAC Address                 
	AOUT_TEMP       .EQUR           r3      ; Audio Output Temp Register
	AOUT_LTAIL       .EQUR           r5     ; Left Audio Tail Pointer
						; (Moved by the ISR Only)
	AOUT_LHEAD       .EQUR           r4     ; Left Audio Head Pointer
						; (Moved by CSX Synth only)
	AOUT_RTAIL       .EQUR           r7     ; Right Audio Tail Pointer
						; (Moved by the ISR Only)
	AOUT_RHEAD       .EQUR           r6     ; Right Audio Head Pointer
						; (Moved by CSX Synth only)


; Registers used by the Main DSP Thread
; -------------------------------------
; These registers are the names and other names of commonly used
; registers by the main thread.

; Scratch Registers
	CX1             .EQUR           r12      ; Scratch register 1
	CX2             .EQUR           r13      ; Scratch register 2
	CX3             .EQUR           r8      ; Scratch register 3
	CX4             .EQUR           r9      ; Scratch register 4

; Other names used for CX3 and CX4 scratch registers
; Note: CX1 and CX2 are never used by any other name.        

	HEAD            .EQU            CX3     ; Head Pointer address
	TAIL            .EQU            CX4     ; Tail Pointer address



