; =========================================================               
; CSXMMAP.INC: This file contains the includes needed to 
; place memory buffers in the appropriate place, allowing
; for taking advantage of the wrap around buffers in the DSP.
; =========================================================
; Copyright, 1995 Atari Corporation.
; Written for Atari by Highlight Software Solutions.
; =========================================================



; =========================================================
CSX_DAT         EQU     D_RAM +(2*1024) ; 2K bytes
.ORG CSX_DAT                            ; 6k bytes below top of memory


;============= OBUF_L ===============================================
; This buffer is used to output left channel audio for the isr.
; Size: Must be multiple of 1024 (4 Maxiblock) words (2048 bytes)
OBUF_L:
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1K bytes

dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 2K bytes


;============= OBUF_R ===============================================
; This buffer is used to output right channel audio for the isr.
; Size: Must be multiple of 1024 (4 Maxiblock) words (2048 bytes)
OBUF_R:
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1K bytes

dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 2K bytes


;============= IBUF ===============================================
; This buffer is used to fetch packed data from 68K space to DSP.
; Size: Must be 256 (Maxiblock) long words (1024 bytes)  + 10 long words
; for potential worst case header.
IBUF:        
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 256 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 512 bytes
 dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 768 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; 1024 bytes
dc.l    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0        ; 64 bytes per line
; HEADER OVERFLOW (16 long words).
; =========== HBUF =================================================
; This smaller buffer is used to store the current maxiblock header.
; Size: Must be maximum CSX Header size moved to longs. 
; Using 10 Longs, this is a small cushion
HBUF:
dc.l    0,0,0,0,0,0,0,0,0,0                     ; 10 longs (40 bytes)

CSX_EOI:                                        ; One word past end of input
dc.l	0					; 1 long (4 bytes)

CSX_HOI:                                        ; Half way pt of input
dc.l	0					; 1 long (4 bytes)

CSX_CHANNEL:
dc.l	0					; stereo (0), mono (1)

; ==================================================================
; DEBUG REGISTER'S USED TO PRINT DEBUG INFO
CSXDB:
CSXDEBUG1:
dc.l	0					; 1 long
CSXDEBUG2:
dc.l	0					; 1 long
CSXDEBUG3:
dc.l	0					; 1 long
CSXDEBUG4:
dc.l	0					; 1 long
CSXDEBUG5:
dc.l	0					; 1 long
CSXDEBUG6:
dc.l	0					; 1 long
CSXDEBUG7:
dc.l	0					; 1 long
CSXDEBUG8:
dc.l	0					; 1 long
CSXDEBUG9:
dc.l	0					; 1 long
CSXDEBUG10:
dc.l	0					; 1 long
CSXDEBUG11:
dc.l	0					; 1 long
CSXDEBUG12:
dc.l	0					; 1 long
CSXDEBUG13:
dc.l	0					; 1 long
CSXDEBUG14:
dc.l	0					; 1 long

