#pragma hdrstop
#include <windows.h>

#include "exnames.h"

static struct exTable {const char*t; DWORD id;} xnames[] = {
{"EXCEPTION_ACCESS_VIOLATION"     , STATUS_ACCESS_VIOLATION       },
{"EXCEPTION_DATATYPE_MISALIGNMENT", STATUS_DATATYPE_MISALIGNMENT  },
{"EXCEPTION_BREAKPOINT"           , STATUS_BREAKPOINT             },
{"EXCEPTION_SINGLE_STEP"          , STATUS_SINGLE_STEP            },
{"EXCEPTION_ARRAY_BOUNDS_EXCEEDED", STATUS_ARRAY_BOUNDS_EXCEEDED  },
{"EXCEPTION_FLT_DENORMAL_OPERAND" , STATUS_FLOAT_DENORMAL_OPERAND },
{"EXCEPTION_FLT_DIVIDE_BY_ZERO"   , STATUS_FLOAT_DIVIDE_BY_ZERO   },
{"EXCEPTION_FLT_INEXACT_RESULT"   , STATUS_FLOAT_INEXACT_RESULT   },
{"EXCEPTION_FLT_INVALID_OPERATION", STATUS_FLOAT_INVALID_OPERATION},
{"EXCEPTION_FLT_OVERFLOW"         , STATUS_FLOAT_OVERFLOW         },
{"EXCEPTION_FLT_STACK_CHECK"      , STATUS_FLOAT_STACK_CHECK      },
{"EXCEPTION_FLT_UNDERFLOW"        , STATUS_FLOAT_UNDERFLOW        },
{"EXCEPTION_INT_DIVIDE_BY_ZERO"   , STATUS_INTEGER_DIVIDE_BY_ZERO },
{"EXCEPTION_INT_OVERFLOW"         , STATUS_INTEGER_OVERFLOW       },
{"EXCEPTION_PRIV_INSTRUCTION"     , STATUS_PRIVILEGED_INSTRUCTION },
{"EXCEPTION_IN_PAGE_ERROR"        , STATUS_IN_PAGE_ERROR          },
};
static int nxnames = sizeof(xnames)/sizeof(xnames[0]);

char* Exname(unsigned long code)
{
	for (int i=0; i<nxnames; i++)
	{
		if (xnames[i].id == code)
		{
			return (char*)xnames[i].t;
		}
	}
	return 0;
}

