/******************************************************************************\

	LINKER.CPP
	Written by Rudy Mathieu

\******************************************************************************/
#include <stdlib.h>
#include "linker.h"
#include "dbgnew.h"
int LINKLIST::add(void *ptr)
{
   LinkStruct *chunk=DBG_NEW(LinkStruct);//new LinkStruct;
   if (chunk==NULL) return -1;
   chunk->handle=nexthandle;
   chunk->data=ptr;
   chunk->prev=tail;
   chunk->next=NULL;
   if (head==NULL) head=chunk;  // If we have no head then add one
   if (tail) tail->next=chunk;  // If we have a tail then chain chunk
   tail=chunk;                  // This chunk is the tail now
   sizecount++;
   return nexthandle++;
}

int LINKLIST::removehead()
{
  LinkStruct* p = head;
  if (p==0) 
  {
    return -1;
  }
  head = head->next;
  if (head)
  {
    head->prev = 0;
  }
  if (current==p) { current=0; currentindex=-1; }
  delete p;
  sizecount--;
  return 0;
}

void* LINKLIST::gethead()
{
  void* p = head?head->data:0;
//  maybe let abs be abs.
//  current = p;
//  currentindex = 0;
  return p;
}

/***************************************************************************
        The Following Class Functions control data by absolute location
****************************************************************************/
int LINKLIST::removeabs(int id)
{
   LinkStruct *chunk=head;
   for (register int i=0; i<id; i++)
   {
      if (chunk==NULL) return -1;
      chunk=chunk->next;
   }
   if (chunk==NULL) return -1;
   if (chunk->prev)
   		chunk->prev->next=chunk->next;       // Previous should point over this ->
   if (chunk->next)
   		chunk->next->prev=chunk->prev;       // Next should point over this <-
   if (chunk==head) head=chunk->next;
   if (chunk==tail) tail=chunk->prev;
   if (current==chunk) { current=NULL; currentindex=-1; }
   delete chunk;
   sizecount--;
   return 0;
}

void *LINKLIST::getabs(int id)
{
   int dest=id-currentindex;
   if (currentindex==-1 || id < abs(dest) )
   {
      LinkStruct *chunk=head;
      if (chunk==NULL || id>=sizecount) return NULL;
      for (register int i=0; i<id; i++) chunk=chunk->next;
      currentindex=id;
      current=chunk;
      return chunk->data;
   }
   if (dest > 0)
   {
      LinkStruct *chunk=current;
      if (chunk==NULL || id>=sizecount) return NULL;
      for (register int i=0; i<dest; i++) chunk=chunk->next;
      currentindex=id;
      current=chunk;
      return chunk->data;
   }
   if (dest < 0)
   {
      dest=abs(dest);
      LinkStruct *chunk=current;
      if (chunk==NULL || id>=sizecount) return NULL;
      for (register int i=0; i<dest; i++) chunk=chunk->prev;
      currentindex=id;
      current=chunk;
      return chunk->data;
   }
   return current->data;
}

/***************************************************************************
        The Following Class Functions control data thouhgh their handles
****************************************************************************/

// Get Data by it's handle
void *LINKLIST::get(int handle)
{
   LinkStruct *chunk=head;
   while (chunk)
   {
      if (chunk->handle==handle) return chunk->data;
      chunk=chunk->next;
   }
   return NULL;
}
// Remove data by an arbitrary but somehow convenient property:
// IT'S ADDRESS!!!
int LINKLIST::removeptr(void *cookie)
{
  LinkStruct* chunk=head;
  while (chunk)
  {
    if (chunk->data == cookie)
    {
      chunk->prev->next = chunk->next;
      chunk->next->prev = chunk->prev;
      if (chunk == head) head=chunk->next;
      if (chunk == tail) tail=chunk->prev;
      delete chunk;
      sizecount--;
      return 0;
    }
    chunk = chunk->next;
  }
  return -1;
}
// Remove Data by it's handle
int LINKLIST::remove(int handle)
{
   LinkStruct *chunk=head;
   while (chunk)
   {
      if (chunk->handle==handle) 
      {
         chunk->prev->next=chunk->next;       // Previous should point over this ->
         chunk->next->prev=chunk->prev;       // Next should point over this <-
         if (chunk==head) head=chunk->next;
         if (chunk==tail) tail=chunk->prev;
         delete chunk;
         sizecount--;
         return 0;
      }
      chunk=chunk->next;
   }
   return -1;
}
