#ifndef __NAVCONST_H
#define __NAVCONST_H
class NavController;
//-----------------------------------------------------------------------------
class NavConState
{
public:
  NavConState(NavController* ct)  : controller(ct), pause(0)  {}
  virtual ~NavConState() {}
  virtual void MouseDown(const CPoint& place, int flags)=0;
  virtual void Key(int code, int flags){}
  virtual void Idle()=0;
  virtual void OnPaint(const CDC& dc, const CRect& r) {}
  virtual void OnAppExit() {}
  virtual BOOL QueryClose() { return TRUE; }
  virtual BOOL OnWindowCreate() { return TRUE; }
  virtual void ResumePlay() { pause=0;}
  virtual void PausePlay() {pause=1;}
  virtual void PlayReminder();
  virtual void GoPlay() {}
  virtual BOOL WantsDialogKeys() { return FALSE; }
  BOOL IsPaused() const { return pause; }

  // Keep this beaut from being a memory fragmentation
  // engine.
  void* operator new(size_t);
  void operator delete(void*);
protected:
  NavController* controller;
  int pause;

private:
  // The one NavConState object you can have
  // is actually a static allocation.
  enum { myBlockSize=128 };
  static unsigned char myOneStaticBlock[2][myBlockSize];
  static int allocatedBlocks;
};

void SetState(NavConState* s);
#endif