#ifndef __PROMPTS_H
#define __PROMPTS_H

class GameWindow;
class FileManager;
class NavController;
class Film;
class ClipContext;

#include "fontbits.h"
#include "cpnodes.h"

enum { NIL=10000 };
//-----------------------------------------------------------------------------
class PromptManager
{
public:
  PromptManager()
    : node(0)
    , film(0)
    , mouse(0)
    , promptUp(FALSE)
    , promptColored(FALSE)
    , disabledBranches(0)
    //, kTrack(NIL)
    //, kSegment(NIL)
  {
  }
  ~PromptManager()
  {
  }
  void DisableBranch(int kBranch);
  void EnableAllBranches();
  void EndHyper();
  void Manage();
  void NotifyOff();
  void NotifyOn(const ClipContext& context);
  void StartHyper(char* prompt);
  void SetFont(const FontBits& f)
  {
    font = f;
  }
  void SetCurrentNode(CPNode* n) { node = n; }
  void SetCurrentClip(Film* f)   { film = f; }
  void SetMouseNode(CPNode* n)   { mouse = n; }
  void TalkTo(GameWindow* w)
  {
    window = w;
  }
private:
  void DrawCenteredPrompt(const char* text, DWORD color);
  void TakeDownPrompt();
  int disabledBranches;
  BOOL enabled;
  Film* film;         // the clip currently playing.
  FontBits font;
  BOOL lEnabled;
  CPNode* mouse;      // the node that was struck by the mouse (or key)
  CPNode* node;       // the node currently playing
  BOOL promptColored;
  CPSegment promptSeg;
  BOOL promptUp;
  DWORD redTime;
  const char* sourcePath;
  GameWindow* window;
};
#endif