#ifndef __WINDOW_H
#define __WINDOW_H
#include "basewin.h"

//class CMenu;
struct CmdAssoc;

class Window : public BaseWin
{
  public:
    Window()
      : BaseWin()
      , par(0)
      , trackInfoSet(0)
    {
    }
    Window(const CRect& placement, const char* _title, long widgetflag)
      : BaseWin(0, _title, placement, widgetflag)
      , par(0)
      , trackInfoSet(0)
    {
    }
    Window(BaseWin* parent, int _id, const CRect& placement, const char* _title, long widgetflag)
      : BaseWin(_id, _title, placement, widgetflag)
      , par(parent)
      , trackInfoSet(0)
    {
    }
    int AppIsActive() { return fAppActive; }
    BOOL Create();
    //void SetMenu(const CMenu& menu);
    void Close();
    int IsPopup()
    {
      DWORD chStyle = GetWindowLong(GetHWND(), GWL_STYLE);
      return (chStyle & WS_POPUP)?1:0;
		}
    virtual int Idle() { return !AppIsActive(); }
	 virtual BOOL OnCreate();
    virtual void OnDestroy(void);
    virtual int  OnEraseBackground(CDC h) { h.PatBlt(GetInnerRect(), PATCOPY); return 1; }
    virtual void OnMove(int x, int y) {}
    virtual void OnSize(int how, int x, int y) {}
    virtual void OnTimer() {}

		//void SeekAndExecute(CmdAssoc*, int, int);
		void Seek(int,int);
  	void SetSizeTracking(const CSize& minSize, const CSize& maxSize, const CPoint& maxedULC);
    static LRESULT CALLBACK handler(HWND, UINT, WPARAM, LPARAM);
  private:
	void _Move(int x, int y);
	  BOOL trackInfoSet;
  	MINMAXINFO trackInfo;
    BaseWin* par;
    static int fAppActive;

    BOOL    _Creation(/*HWND, WPARAM, LPARAM*/);
    void    _Destruction();
    LRESULT _Size(WPARAM, LPARAM);
    LRESULT _Command(WPARAM, LPARAM);
    void    _Paint(WPARAM, LPARAM);
    LRESULT _Activate(WPARAM, LPARAM);
    void    _Close();
    LRESULT _QueryClose(WPARAM, LPARAM);
    LRESULT _ActivateApp(WPARAM, LPARAM);
    LRESULT _Timer(/*WPARAM, LPARAM*/);
    LRESULT _EraseBackground(WPARAM);
    
	  void _MeasureItem(UINT id, MEASUREITEMSTRUCT* item);
		void _DrawItem(UINT id, DRAWITEMSTRUCT* item);
		int  _CompareItem(UINT id, COMPAREITEMSTRUCT* item);

    virtual BOOL OtherMessage(UINT msg, WPARAM, LPARAM, LRESULT& res);
};
#endif
